<?php
declare(strict_types=1);

namespace App\Doctrine\Organization;

use App\Doctrine\AbstractExtension;
use App\Entity\Access\Access;
use App\Entity\Organization\Organization;
use Doctrine\ORM\QueryBuilder;
use Symfony\Bundle\SecurityBundle\Security;

/**
 * Class CurrentOrganizationExtension : Filtre de sécurité par défaut pour une resource Organization
 * @package App\Doctrine\Core
 */
final class CurrentOrganizationExtension extends AbstractExtension
{
    public function __construct(private Security $security)
    { }

    protected function addWhere(QueryBuilder $queryBuilder, string $resourceClass): void
    {
        if (Organization::class !== $resourceClass) {
            return;
        }

        /** @var Access $currentUser */
        $currentUser = $this->security->getUser();
        $rootAlias = $queryBuilder->getRootAliases()[0];
        $queryBuilder
            ->andWhere(sprintf('%s.id = :organization', $rootAlias))
            ->setParameter('organization', $currentUser->getOrganization()->getId())
        ;
    }
}
